#include <STC15F2K60S2.H>
#include <intrins.h>
#include <NRF24L01.H>
//*********************************************NRF24L01*************************************
#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  20  	// 20 uints TX payload
#define RX_PLOAD_WIDTH  20  	// 20 uints TX payload
uint const TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
uint const RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ
//***************************************NRF24L01Ĵָ*******************************************************
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	//   ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP             0xFF  	// 
//*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG2         0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
//*****************************************ʱ*****************************************
void Delay(unsigned int s)
{
	volatile unsigned int i;
	for(i=0; i<s; i++);
	for(i=0; i<s; i++);
}
//******************************************************************************************
uint 	bdata sta;   //״̬־
sbit	RX_DR	=sta^6;
sbit	TX_DS	=sta^5;
sbit	MAX_RT	=sta^4;
sbit  TX_FULL =sta^0;
/******************************************************************************************
/*ʱ
/******************************************************************************************/
void inerDelay_us(volatile unsigned char n)
{
	for(;n>0;n--);
		{	_nop_();
	_nop_();}
}
//****************************************************************************************
/*NRF24L01ʼ
//***************************************************************************************/
void init_NRF24L01()
{
 	CE=0;    // chip enable
 	CSN=1;   // Spi  disable 
 	SCK=0;   // 
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      //  Ƶ0Զ	ACKӦ	
	//SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x1a);//0x1a); // Զطʱʹ500us + 86us, 10 retrans...
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + RF_CH, 0x40);        //   ŵΪ2.4GHZշһ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x0f);   		//÷Ϊ1MB/S书Ϊֵ+7dBX2401Lţʵ+21dbm
}                          //0x27   0 0 1 0 0 1 1 1   0x0e   0 0 0 0 1 1 1 0
/****************************************************************************************************
/*uint SPI_RW(uint uchar)
/*ܣNRF24L01SPIдʱ
/****************************************************************************************************/
uint SPI_RW(uint uchar)
{
	uint bit_ctr;
   	for(bit_ctr=0;bit_ctr<8;bit_ctr++) // output 8-bit
   	{
		MOSI = (uchar & 0x80);         // output 'uchar', MSB to MOSI
		uchar = (uchar << 1);           // shift next bit into MSB..
		SCK = 1;                      // Set SCK high..
		inerDelay_us(14);
		uchar |= MISO;       		  // capture current MISO bit
		inerDelay_us(14);
		SCK = 0;            		  // ..then set SCK low again
   	}
    return(uchar);           		  // return read uchar
}
/****************************************************************************************************
/*uchar SPI_Read(uchar reg)
/*ܣNRF24L01SPIʱ
/****************************************************************************************************/
uchar SPI_Read(uchar reg)
{
	uchar reg_val;
	
	CSN = 0;                // CSN low, initialize SPI communication...
	inerDelay_us(14);
	SPI_RW(reg);           //ҵҪĵַ
	inerDelay_us(14);
	reg_val = SPI_RW(0);    // ..then ַregistervalue
	inerDelay_us(14);
	CSN = 1;                // CSN high, terminate SPI communication
	
	return(reg_val);        // return register value
}
/****************************************************************************************************/
/*ܣNRF24L01дĴ
/****************************************************************************************************/
uint SPI_RW_Reg(uchar reg, uchar value)
{
	uint status;
	
	CSN = 0;                   // CSN low, init SPI transaction
	status = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	CSN = 1;                   // CSN high again
	
	return(status);            // return nRF24L01 status uchar
}
/****************************************************************************************************/
/*uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
/*: ڶݣregΪĴַpBufΪݵַucharsݵĸ
/****************************************************************************************************/
uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
{
	uint status,uchar_ctr;
	
	CSN = 0;                    		// Set CSN low, init SPI tranaction
	status = SPI_RW(reg);       		// Select register to write to and read status uchar
	
	for(uchar_ctr=0;uchar_ctr<uchars;uchar_ctr++)
		pBuf[uchar_ctr] = SPI_RW(0);    // ִжĲ
	
	CSN = 1;                           
	
	return(status);                    // return nRF24L01 status uchar
}
/*********************************************************************************************************
/*uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
/*: дݣΪĴַpBufΪдݵַucharsдݵĸ
/*********************************************************************************************************/
uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
{
	uint status,uchar_ctr;
	
	CSN = 0;            //SPIʹ       
	status = SPI_RW(reg);   
	for(uchar_ctr=0; uchar_ctr<uchars; uchar_ctr++) //
	SPI_RW(*pBuf++);
	CSN = 1;           //رSPI
	return(status);    // 
}
/****************************************************************************************************/
/*void SetRX_Mode(void)
/*ܣݽ 
/****************************************************************************************************/
void SetRX_Mode(void)
{
	CE=0;
	SPI_RW_Reg(0xE2,0xff);   //RX FIFO
	SPI_RW_Reg(WRITE_REG + CONFIG2, 0x0f);   		// IRQշжӦ 16λCRC	
	CE = 1; 
	inerDelay_us(1560);    //ĿΪģ㹻ʱյ
}
/******************************************************************************************************/
/*unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
/*ܣݶȡrx_bufջ
/******************************************************************************************************/
unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
{
  unsigned char revale=0;
	sta=SPI_Read(STATUS);	// ȡ״̬Ĵжݽ״
	if(RX_DR)				// жǷյ
	{
	    CE = 0; 			//SPIʹ
		SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
		revale =1;			//ȡɱ־
	}
	SPI_RW_Reg(WRITE_REG+STATUS,sta);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	   CE=1;                                                                     //
	return revale;
}
/***********************************************************************************************************
/*void nRF24L01_TxPacket(unsigned char * tx_buf)
/*ܣ tx_buf
/**********************************************************************************************************/
void nRF24L01_TxPacket(unsigned char * tx_buf)
{
	//SPI_RW_Reg(WRITE_REG+STATUS,0xff);
	 SPI_RW_Reg(0xE1,0xE1);
	CE=0;
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH);
	SPI_RW_Reg(WRITE_REG + CONFIG2, 0x0E);//16λУ
	CE=1;
	inerDelay_us(14);   //CEߵƽ10usܽ뷢ģʽ
}